<?php

include '../../core.php';

checkAuth("pkiAdmin");

cabecera (3);

echo "<h1 class='title'>Baja de Autoridad de Registro</h1>";

$command = $_POST['command'];
$errorCode = "a0";

switch ( $command ) {
   default :
      echo "<h2>Seleccione la RA que quiere dar de baja</h2>\n";

      // Buscamos todas las RA disponible en el sistema
      $filter = "(objectClass=pkirisAuthority)";
      $justthese = array("pkirisName","pkirisCopaID","description");
      $result = ldap_get_info($ldapVar['base'], $filter, $justthese);

      if (!$result)
         $errorCode = "a2b2c2d1e1";
      else if ( $result['count'] == 0 )   
         echo "No se ha encontrado ninguna Autoridad de Registro en el sistema.";
      else {
         echo "<table border='0' cellpadding='0' cellspacing='0' !width='100%'>
         <tr>
	 <td class='header'>Copa Id</td>
	 <td class='header'>Nombre de la RA</td>
	 <td class='header'>Descripci&oacute;n</td>
	 <td class='header'>Certificados Activos</td>
	 <td class='header'>Peticiones enviadas a la CA</td>
	 </tr>\n";

         for($i = 0; $i < $result["count"]; $i++) {
            $queryCopa = $result[$i]["pkiriscopaid"][0];
            $queryRaName = $result[$i]["pkirisname"][0];
            $queryDescr = $result[$i]["description"][0];

            $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$queryCopa*)(pkirisStatus=issued))";
            $justthese = array("dn");
            $certIssued = ldap_get_info($ldapVar['base'], $filter, $justthese);
	    if ( !$certIssued )
	       $errorCode = "a2b2c2d1e1";
            else {
	       $certIssuedNum = count($certIssued) -1;

	       $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$queryCopa*)(|(pkirisStatus=ra2ca)(pkirisStatus=revoke)))";
               $justthese = array("dn");
               $certRa2ca = ldap_get_info($ldapVar['base'], $filter, $justthese);
               if ( !$certRa2ca )
                  $errorCode = "a2b2c2d1e1";
               else {
                  $certRa2caNum = count($certRa2ca) -1;
              
                  echo "<form method='post' action='delRa.php' enctype='multipart/form-data' name='delRa_form'>
			<input type='hidden' name='copa' value='$queryCopa' />
                        <input type='hidden' name='command' value='have_copa' />\n"; 

                  if ($i%2==0) {
            	      echo "<tr>
                              <td class='even'> $queryCopa </td>
                              <td class='even'><input class='button2' type='submit' value='$queryRaName' /></td>
                              <td class='even'> $queryDescr </td>
                              <td class='even'> $certIssuedNum </td>
                              <td class='even'> $certRa2caNum </td>
                            </tr>
                          </form>\n";
            	  }
	          else {
                     echo "<tr>
            	             <td class='odd'> $queryCopa </td>
                             <td class='odd'><input class='button2' type='submit' value='$queryRaName' /></td>
	                     <td class='odd'> $queryDescr </td>
         	             <td class='odd'> $certIssuedNum </td>
            	             <td class='odd'> $certRa2caNum </td>
	                   </tr>
                        </form>\n";
            	  }   
	       }
            }
         } 
         echo "</table>
               <p>No podra borrar una RA en la cual todav&iacute;a se encuentren certificados activos o peticiones enviadas a la CA, como por ejemplo revocaciones, peticiones de firma/renovaci&oacute;n, etc.</p>";           
      }
      break;

      case "have_copa":

	 $command = $_POST['command'];
	 $copa = $_POST['copa'];
	
         // Volvemos a comprobar los certificados activos de la RA
         $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa*)(pkirisStatus=issued))";
         $justthese = array("dn");
         $certIssued = ldap_get_info($ldapVar['base'], $filter, $justthese);
         if ( !$certIssued )
            $errorCode = "a2b2c2d1e1";
         else {
            $certIssuedNum = count($certIssued) -1;

            $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa*)(|(pkirisStatus=ra2ca)(pkirisStatus=revoke)))";
            $justthese = array("dn");
            $certRa2ca = ldap_get_info($ldapVar['base'], $filter, $justthese);
            if ( !$certRa2ca )
               $errorCode = "a2b2c2d1e1";
            else {
               $certRa2caNum = count($certRa2ca) -1;
               $certTotalNum = $certIssuedNum + $certRa2caNum;
            
     	       if ($certTotalNum > 0) 
	          $errorCode = "a2b2c2d2e7";
               else {
                  $filter = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$copa))";
                  $justthese = array("dn","pkirisName","pkirisRaUrl");
                  $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
                  if ( !$result )
      	             $errorCode = "a2b2c2d1e1";
                  else if ( $result['count'] == 0 )
                     $errorCode = "a2b2c2d2e4";
                  else {
  	             $delRaDn = $result[0]["dn"][0];
                     $delRaName = $result[0]["pkirisname"][0];
                     $delRaUrl = $result[0]["pkirisraurl"][0];
	    
       	             $filter = "(pkirisCopaID=$copa*)";
                     $justthese = array("dn");
                     $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
                     if ( !$result )
                        $errorCode = "a2b2c2d1e1";
                     else {
	                for($i=0; $i<count($result)-1; $i++) 
	                   $delResult=ldap_del_record($result[$i]["dn"]);

         	        if ( !$delResult )
      		           $errorCode = "a2b2c2d1e2";
		        else if ( $delRaUrl != '') { 
	                   // Borramos el archivo de configuracion si existe
                           $confFile = $dirVar['conf']."php/".$delRaUrl.".conf";
                           if ( !file_exists($confFile) )
                              $errorCode = "a2b2c2d2e5";
                           else {
              	              $delConfFile = unlink($dirVar['conf']."php/".$delRaUrl.".conf");
	                      if ( !$delConfFile ) 
			         $errorCode = "a2b2c2d2e2";
                           }
		     
	                   // Borramos el link simbolico 
                           $linkFile = $dirVar['web'].$delRaUrl;
                           if ( !file_exists($linkFile) )
                              $errorCode = "a2b2c2d2e6";
                           else {
            		        $delLinkFile = unlink($dirVar['web'].$delRaUrl);
	            	        if ( !$delLinkFile ) 
		                 $errorCode = "a2b2c2d2e3";
	                      else {
	                         echo "<p>La baja de la Autoridad de Registro \"$delRaName\" se ha realizado con &eacute;xito.</p>";
		                 // Registramos la accion en el fichero de log
                                 $pkiLog['status'] = "delRa";
                                 $pkiLog['eee'] = $copa;
                                 $pkiLog['user'] = "PKIAdmin";
                                 $pkiLog['error'] = $errorCode;
                                 writeLog ($pkiLog);                     
                              }
                           }
	                }
                     }
                  }
               }
            }
         }
      break;
}
			
// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error borrando la Autoridad de Registro $newRaName </h2>\n";
   $pkiLog['status'] = "delRa";
   $pkiLog['eee'] = $newRaNum;
   $pkiLog['user'] = "PKIAdmin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}
								      
pie ();

?>
